The Desktop Toolbox
Open, Needs TriagePublic

Description

This little thingy serves the following purposes:

  • Displays the name of the current activity when it's not in the corner
  • Offers a non-right-clicking method of accessing various (but not all) features present in the desktop's context menu -- most notably changing the wallpaper
  • Offers an emergency UI for editing widgets and logging out/shutting down in the case that the user has deleted all their panels and any of the application launchers/menus, and doesn't know how to right-click or doesn't have an input device that allows them to

However, it presents the following issues:

  • The "name of current activity" feature is not very discoverable since it requires dragging the widget out of a corner
  • The "emergency escape valve" feature is underdeveloped for the "Help I deleted the default panel" use case because it doesn't offer the ability to re-add the default panel (this is only in the desktop context menu)
  • In general, the menu's contents are quite different from the desktop context menu, so it doesn't feel like a left-click UI for the right-click desktop context menu
  • It feels "useless" somehow and many people (myself included) have the inexplicable urge to get rid of it.
  • Since it has no text by default, nobody knows what to call it so anyone who wants to get rid of it can't easily Google their way to success. A very common user question is "How do I get rid of this thing? What even is it?"

My sense is that its goals are laudable. People should be able to see the name of the current activity (if there are more than one). They should be able to change the wallpaper without having to right-click on the desktop. They should have some kind of emergency escape valve if they've accidentally destroyed the UI by removing Kickoff and/or the whole default panel.

However I'm not sure that the Desktop Toolbox is the best way to ensure these things. It feels like an add-on, and that those functions should be provided more naturally.

Thoughts?

rooty added a subscriber: rooty.Jan 26 2019, 3:00 PM

I also tend to tuck it away as quickly as possible after setting up Plasma for someone for the first time.

Can the panel be adapted to show the name of the current activity instead of the toolbox?

I do like the emergency aspect of it, though. As a sort of safety net if you're unable to right click or use krunner to reboot.

I could go either way in terms of keeping it or removing it to be honest.
Sorry I couldn't be of more help.

I'll note that most of the above-mentioned issues are solvable without much difficulty:

  • Making it always show its label even when it's in a corner would solve the problem of the activity name feature being non-discoverable, and it would give people some text to Google so they can figure out how to get rid of it if they don't like it
  • We could make its selection of menu items identical to those of the Desktop context menu, which would make that aspect more obvious and solve the problem of not being able to use it to restore the default panel

However, that still leaves the "it feels useless and people want to remove it" problem. It remains to be seen if the above functional changes would be sufficient to solve the emotional problem of people just not liking it.

ndavis added a subscriber: ndavis.Jan 26 2019, 4:12 PM

On the other hand, if we want to remove it, we need to find alternative ways to provide the following features:

  1. An escape value if you destroy the UI by accident (e.g. by deleting the default panel) without needing to right-click
  2. A way to change the wallpaper without needing to right-click
  3. A visible way to see the name of the current activity
  4. A way to lock/unlock/edit widgets without needing to right-click when there is no panel. See also T10190: (Re)define modes when editing panels and widgets
  1. we can make the default panel added automatically when it removed and the desktop is empty from panels or we can make one panel fixed (we called default)

2 . throw setting anyone can change the wallpaper it make sense (if no need for right click I think right click is default in all desktops windows , mac ,...etc.)

  1. throw activity manager if u need to see your desktop name or number u do the same (maybe with hot corner)
  2. we can shortcut for this I think its better to have advanced setting like this hidden some where (my opinion) in many case some people don't know what to do when something change in the default view of the desktop (panels , clock , tray .. etc.) I think its better to make it locked by default customizable when needed (simple by default, powerful when needed)

what do u think

Offers an emergency UI for editing widgets and logging out/shutting down in the case that the user has deleted all their panels and any of the application launchers/menus, and doesn't know how to right-click or doesn't have an input device that allows them to

Or has set it so that right click performs a different action.

My 2 cents:
That's also the first thing I do as soon as I get a new install!

That being said, the name, when it's on the corner, could be solvable by hovering the toolbox with the mouse cursor to reveal it's name (popup label)

As to the escape hatch, that's a very needed feature, but that "thing" is not solving it!

There's a bug report about a plasma option to reset the desktop - now, if we had that and this would shortcut to that option, or have an undo option (for the not-so-damaged desktop situations) that would be useful.

But, then again, so would right click!
I think right click is pretty much in everyone's head already, so... I don't see the problem with using the right click instead of the toolbox.

(I didn't like codezela's 1st point because a user may REALLY want it's desktop panel-free...)

its an easy checkbox in the setting or throw right click

  • Hide all panells

xd

There's a bug report about a plasma option to reset the desktop - now, if we had that and this would shortcut to that option, or have an undo option (for the not-so-damaged desktop situations) that would be useful.

This could work, yeah.

I think right click is pretty much in everyone's head already, so... I don't see the problem with using the right click instead of the toolbox.

We don't build UIs where functionality is available only through a right-click. It's right there in our HIG: https://hig.kde.org/components/navigation/contextmenu.html. In particular, it wouldn't be acceptable to only let people change the wallpaper via a context menu.

Context menus are accelerators for experts, but all of their functionality must also be available via some visible method accessible when you only left-click. Besides, as @davidedmundson brought up, it's possible to break your right-clicking ability on the Plasma desktop (which is not ideal, but for the moment it is what it is).

We don't build UIs where functionality is available only through a right-click. It's right there in our HIG: https://hig.kde.org/components/navigation/contextmenu.html. In particular, it wouldn't be acceptable to only let people change the wallpaper via a context menu.

OK, then maybe some of them really do belong on the toolbox and maybe a few others - such as the options to fix your desktop.

I really do like the idea of that toolbox, I just don't see anything useful for it in it's current shape - I get the feeling it does not bring anything good enough that justifies it being there.

Now, with the right options it can be a keeper and maybe even a must-have!

My best idea is shortcuts to Desktop Fixes, Krunner, lock/unlock widgets, add panels/widgets and maybe some desktop related preferences (wallpaper, alignments, etc)

(I'm sorry, I'm not on Linux so I'm probably mentioning things that are already there... I have a terrible memory :p)

Zren added a subscriber: Zren.Feb 19 2019, 6:18 PM

without needing to right-click

Most Android phones have a "long press the wallpaper" to enter "edit mode". This would not be discoverable to new users, but would be a familiar... "gesture" to users of existing touch devices.

Not sure where the HIG stands on "long presses" though. We already use "long presses" for "resizing widgets", however the desktop toolbox skips the need to perform that "long press" since it opens up every desktop widget's... "sidebar with the resize handles" when you click the desktop toolbox.

Currently the only place that we use long press (to my knowledge) is to enter the Widget's own private edit mode. I'm not real thrilled about that TBH, but I could accept it as a secondary, touch-centric UI once we have a better desktop-specific UI for it (See T10190: (Re)define modes when editing panels and widgets)

Here's my analysis of the features that the Desktop Toolbox provides:

  • Shows the name of the current activity in its title when it's not in the corner - Useful, though this feature is so hidden that probably almost nobody actually knows about it
  • Paste clipboard contents - Potentially useful but begs the question of why other file-specific actions aren't also in the Desktop Toolbox. I'll note that our major closed-source competitors (macOS and windows) have all of the functionality for manipulating desktop icons exclusively accessed via a context menu or keyboard shortcuts, so it may not be the worst thing in the world if we do likewise.
  • Undo - Ditto ^^
  • Refresh Desktop - Unnecessary; niche feature at best
  • Show Desktop/Hide Desktop - Unnecessary and also useless; if you can see the Desktop Toolbox at all, you don't need this; if you can't, then it's inaccessible! Would make more sense to just have the appropriate widget in the panel by default (https://bugs.kde.org/show_bug.cgi?id=381295)
  • Activities... - Unnecessary; seems more like an advertisement for the feature than something that's really useful to have globally accessible like this
  • Lock widgets/Unlock Widgets - Unnecessary; can be considered expert functionality and relegated to the context menu exclusively
  • Open with Dolphin - Unnecessary; there's no real reason to have a quick way to open the desktop folder in Dolphin since Folder View itself already shows the files there!
  • Configure Desktop... - Critically important, since it's the only visible way to configure the wallpaper
  • Lock screen - Unnecessary; this functionality lives in Kickoff/Kicker/whatever by default. Any user who deliberately removes that knows what they're doing. Any user who accidentally removes it would be better served by an easier way to get it back than they would by a secondary way to lock the screen
  • Leave - Ditto ^^

In my estimation, the only features in the desktop toolbox that would be potentially missed are showing the name of the current activity, and the Configure Desktop... menu item (because without this, it would be harder for people to figure out how to change the wallpaper).

I think we could safely remove the Desktop Toolbox entirely if we can come up with another place to put these. Thoughts and ideas?

GB_2 added a subscriber: GB_2.Feb 20 2019, 2:56 PM

Do you really need to know the name of the activity? When you switch activities you already know to which one and the desktop toolbox currently only shows the name when not in the corner anyways. We could make a widget that shows the current activity name though.

Not being a user of Activities myself, I have a hard time commenting on whether it's really necessary or not, but I suspect it is just a nice-to-have since the Desktop Toolbox only fulfills this function when it's been deliberately dragged out of the corner.

I use Activities and I have no idea what would I need the Desktop Toolbox for. I disabled it right from the start and never miss it. It's one of the things that you are ashamed of when showing Plasma desktop to others and quickly show how to get rid of because it automatically creates friction: what the hell is it doing on my desktop? Nobody uses it and no other DE has it - for a good reason. Desktop Toolbar is like an ugly mole on the desktop's face so to speak, definitely not a beauty mark...

All the above pointed out Desktop Toolbox usabilities are easily and MORE INTUITIVELY accessible by other means so in reality there are no real pros. Right click on desktop is all people need and are used to (at least all non-Gnome users).

Nate, allow me to use your list to show my points:

  1. Shows the name of the current activity - since Activities allow for different wallpapers and certain settings and now with Latte for different layouts, it's very clear what Activity we are on right now. If that wouldn't be obvious, there would be no point of having Activity in the first place. Also, there are applets like title applet from latte developer that is capable to show Activity name on the panel. Yes, it's not accessible by default, but again, Activities is an advanced option and for full usability, we need additional tools for it anyway (like latte).
  2. Paste clipboard contents - Right-click or shortcuts are widely used EVERYWHERE plus the Clippboard applet/icon is already part of the Plasma systray so why doubling the effort and especially in such an awkward way? Yes, Desktop Toolbar is very awkward and in the way.is
  3. Undo - undo what? Paste? This is usually part of a particular app. I don't see any reason to any Undo feature on the desktop itself. This concept is bizarre and I frankly don't get it. I suspect that most people would be baffled by it. Undo action in an app - yes, undo on the desktop level? What? This is already grayed out as it's fully useless.
  4. Refresh Desktop - Why? What is it doing? Is Desktop stuck somehow? If so, it's not working correctly then. Maybe on some occasion, it may be useful, I don't know, I never need it in 4 years of using Plasma.
  5. Show Desktop/Hide Desktop - this is funny. If I see it, I already see the desktop... Minimize All applet is doing its job so much better.
  6. Activities - there are many other ways to switch them: shortcuts (I set super+tab), active corners, mouse gesture, edge on a touch bar screen, applet. Activities is an advanced feature for a small number of users who know Plasma well and try to utilize its full potential. It's already a confusing concept for beginners so this doesn't need to be exposed. Those who use Activities can handle it without Desktop Toolbox easily.
  7. Lock widgets/Unlock Widgets - easily accessible with right-click on a desktop, exactly where it should be. Right-click is easier and quicker then targetting Desktop Toolbar with a mouse and then click.
  8. Open with Dolphin - this seems to be confusion somewhere. Nate says something about configuring wallpaper while this opens simply Desktop in Dolphin. Maybe it depends on the desktop mode? Anyway, Dolphin as a default file manager is a vital part of the DE, so like any good file manager, it has a shortcut to the Desktop. No need to have a special and extraneous option in a Toolbox. In fact, this is a confusing thing because I had to use it to know what it does. Naming it simply "Open with Dolphin" just raises the question "Open what?" and the answer is "Desktop" of course but still this is accessible by more intuitive place, Dolphin quick access shortcuts.
  9. Configure Desktop - accessible on right-click, where people would look for it as most of us are taught by Windows. It would be a big flaw not to have it under desktop right-click, but in a Toolbox? Why doubling the effort again?
  10. Lock screen - if someone needs or like it, it can be set when it starts, I personally find it useless and it's one of the very first things I disabled after installing the system. It's also on the start menu in case someone wants to have it manually and for advanced users, there is a shortcut and probably other ways to trigger it.
  11. Leave - also in start menu where people look for it. Alternatively, some like it on the panel. On a desktop and under a menu this is weird beyond words.

Has anyone tried to remember when any of you saw Desktop Toolbox on a PERSONALIZED Plasma screenshot? This is certainly some indication on the Desktop Toolbox popularity or rather lack of thereof. Looking on screenshots is maybe statistically flawed method but it's still telling a lot.

In fact, Desktop Toolbar not only doesn't bring ANY real perks, but it also creates a problem for new users who simply don't know what to do with it and don't know how to get rid of it as it simply gets in their way of using or even looking on the desktop.

And the most argument of all, I don't see here any real supporter of the Desktop Toolbar... So why we are even discussing it? It looks like we all agree that this is a bad feature and the discussion is to justify the decision. Desktop Toolbox doesn't provide any unique options, it doesn't provide any convenience, it only disturbs people. This nightmarish experiment should end long ago.

As to discovering long-press for widget's options, that's a completely different issue and I don't see how the Toolbox changes anything. I never knew before reading here that clicking on Toolbox activates this option on a widget... because I don't use on-desktop widgets (only a few of them on the panel or a dock). So someone must discover that feature to have better discoverability of the widget options...? This is absurd. Why not have the option to trigger widget options on widget right-click? I bet that most try to find it that way, but this is a different topic so let's leave it here.

I think the most important thing which you haven't covered in your rant is the following, because you are always talking about the right click menu which is fine when the default settings are active.

Offers an emergency UI for editing widgets and logging out/shutting down in the case that the user has deleted all their panels and any of the application launchers/menus, and doesn't know how to right-click or doesn't have an input device that allows them to

Or has set it so that right click performs a different action.

Yeah. There are many circumstances where right-click isn't good enough or even usable at all:

  • When you're using a touchscreen
  • When you're using a laptop with a buttonless touchpad that makes right-clicking hard and annoying
  • When you're a novice user, especially when paired with a laptop that has a buttonless touchpad
  • When you've intentionally or unintentionally disabled the right-click functionality

Right-clicking is an accelerator for experts, not a general-purpose user interface. Always ask yourself "if I couldn't right-click, how would this work?" If the answer is ever, "it wouldn't", then you need to fix that. :-)

Plasma has separate touchscreen settings (edges) so maybe this could utilize some missing desktop features instead the desktop toolbox? I don't use touchscreens but is there really no right-click possible on them? I find it hard to believe. What about long push or double-finger tap?

Right-clicking is an accelerator for experts, not a general-purpose user interface. Always ask yourself "if I couldn't right-click, how would this work?" If the answer is ever, "it wouldn't", then you need to fix that. :-)

I disagree. Right-click is so basic that the lack of it is an abnormal situation (and requires fixing) that prohibits from normal or productive desktop OS usage so this cannot be the pretext to uphold desktop toolbox. If someone is not handling that basic thing as right-click, how can we expect that person to handle anything on the computer? Maybe I'm narrow minded but people who can't do right-clicks are only utilising most basic system functions, mostly for media consumption+browsing and they rarely do any serious work on a computer. They also don't customize system and they are not interested in computers. They relay on family members and friends which they do call often. I know such persons around me they don't grasp the right-click and they have constant trioubles with basic things so they need constant help... They surely won't understand Desktop Toolbox concept (even I can't understand the reason for its existence) so if someone has no right-click or can't do that - Dekstop Toolbox won't help them either. In fact, they will be even more confused. They don't touch things they don't understand and yet they accidentally touch and click things which leads them to constant troubles...

On that notice, is there really an option to disable right-click in Plasma? I didn't know that and never heard anyone do that on purpose. If such things exists, it's probably a dangerous and superfluous option. Or maybe my imagination is too limited to understand such sytem usage cases? Hm...

Pads (libpinput drivers) usually accept two-finger tap as the right-click. Yes, not all know that but laptop pads even without buttons do have right-click built-in and matter if it's convinient or not shouldn't influence this discussion. If it's not, it's up to the user to find out alternative (like the mentioned two-finger tap).

We cannot cater system to computer analphabeths. Mobile OSes already do that and we shouldn't compete with that... Again, Desktop Toolbox is more complicated and esoteric concept then right-click itself so the premise it can be its crouch is absurd. Most people who do utilize right-click don't understand Desktop Toolbox either, hence the painful effect when they first see it and why we want to get rid of it as soon as possible.

Can't we just create pools on most popular distro forums to see what people think about it? Ubuntu, Mint, Debian, Open Suse, Arch, Manjaro and few others should suffice and bring vaild sample on the Desktop Toolbox usage. Such pools must utilize the same and well constructed questions. This is some work but if there is a confirmation needed and talk is just talk, isn't it at least a some method to gather the data? Or maybe create some pool on official KDE site and post it on main disto forums so people could participate? Of course such sample would be skewed but this is always the case in Linux community which is atypic in comparision to general population.

This type of discussion requires data and KDE community should work out ways to obtain such data in face of lack of proper data gathering by systems and the Plasma DE.

I agree that the Desktop Toolbox is something I always remove on a new install of Plasma, it serves very little purpose. Everything that is in it that isn't on the right click menu could be added like "Refresh Desktop" making that experience better.

  • When you're using a touchscreen
  • When you're using a laptop with a buttonless touchpad that makes right-clicking hard and annoying
  • When you're a novice user, especially when paired with a laptop that has a buttonless touchpad
  • When you've intentionally or unintentionally disabled the right-click functionality

I disagree with some of this because most if not all have some sort of solution for this.

Touchscreens usually offer a Right Click function with a 2 Finger Tap or a Press and Hold 1 Finger.
On Buttonless touchpads you can hold down Ctrl and click with the touchpad for a right click.

However I do agree with the point about the novice user not knowing this stuff but there are plenty of other things to fix for Novice users as well. :D

Always ask yourself "if I couldn't right-click, how would this work?" If the answer is ever, "it wouldn't", then you need to fix that. :-)

I totally agree with that.

mglb added a subscriber: mglb.Mar 29 2019, 8:32 AM
  1. An escape value if you destroy the UI by accident (e.g. by deleting the default panel) without needing to right-click

When last panel is being removed, an user is asked for confirmation. After confirmation, the panel is removed and menu button appears in the panel's place (like it was always here, but was hidden under the panel). The button is movable.

This way:

  • Most users who doesn't need it won't see it
  • Someone who removed last panel (by mistake) will notice it immediatelly - this will be something new, in a place where the user is looking. Current button is probably seen by user's brain as a part of wallpaper after some time.
  • Advanced user who intentionally removed last panel will disable the button like it is done currently. At this point there is (at least) KRunner, so the user is not really stuck. Also, if someone clicks "remove panel", agrees to remove the panel in a message box, misses message with "undo" button, opens the "emergency menu", desktop settings, "Tweaks" tab, unchecks "show the desktop toolbox", all by mistake, the only option is to introduce "child mode" with all settings locked with password.

Displays the name of the current activity when it's not in the corner

The "name of current activity" feature is not very discoverable since it requires dragging the widget out of a corner

  1. A visible way to see the name of the current activity

People should be able to see the name of the current activity (if there are more than one).

What about Activity Bar? This is what widgets are for. This way is even more flexible (name on a panel? No problem).

Offers a non-right-clicking method of accessing various (but not all) features present in the desktop's context menu -- most notably changing the wallpaper

They should be able to change the wallpaper without having to right-click on the desktop.

  1. A way to change the wallpaper without needing to right-click

Launcher → System Settings → ... huh, I didn't know this is not here :)
I think this is how it should be resolved. It is done so in all popular systems (desktop and mobile) and some other Linux desktops (at least Gnome)

and doesn't know how to right-click

I hope this is about "how to right-click on THIS" and not "I need to right-what?" ;)

Since it has no text by default, nobody knows what to call it so anyone who wants to get rid of it can't easily Google their way to success. A very common user question is "How do I get rid of this thing? What even is it?"

"remove desktop button in kde" shows nice answer in a box, so it is not that bad. "remove square in kde", "remove corner button in kde", "hide corner button in kde" works too.

The solution from the post's beginning should mostly solve it. For remaining cases or when the solution is not suitable:

  • The user should not need to google this
  • Easy to describe look. I remember when people called it "cashew", as it has old Plasma logo on it.
  • Activity name on the button might be misleading - one of the most popular Google results for "remove desktop menu in kde" (or "remove square in kde") right now calls it "Default button".
  • Adding "Open Plasma Toolbox" tooltip won't hurt.

I think the option for hiding the button is in right place, assuming the configuration dialog will appear in system settings, and optionally in "emergency menu".

We could also improve user manual availability, with really simple concept names and FAQ.

  1. A way to lock/unlock/edit widgets without needing to right-click when there is no panel. See also T10190: (Re)define modes when editing panels and widgets

KRunner? Somewhere in system settings (desktop configuration)?
When an user wants to remove everything and disable right click, they will complain about imposibility of removing anything we come up with.

A bit of offtopic:

Yeah. There are many circumstances where right-click isn't good enough or even usable at all:

  • When you're using a touchscreen
  • When you're using a laptop with a buttonless touchpad that makes right-clicking hard and annoying
  • When you're a novice user, especially when paired with a laptop that has a buttonless touchpad

This should be fixed:

  • Touchscreen, weird touchpad: tap-and-hold
  • Optionally, macOS-way: ctrl + click

Right-clicking is an accelerator for experts, not a general-purpose user interface.

Do you know any research about it (serious question)? I mean right-click, tap-and-hold, or equivalent, not exactly right click in mouseless/touchpadless environment.

Context menus are accelerators for experts, but all of their functionality must also be available via some visible method accessible when you only left-click.

Always ask yourself "if I couldn't right-click, how would this work?" If the answer is ever, "it wouldn't", then you need to fix that. :-)

The alternative method does not need to be easily accessible in all cases (like mandatory wallpaper changer just two left-clicks away). Visibility is not an issue when you put it in a place expected by an user (again, like wallpaper changer in the system settings).

BTW. Please introduce similar rule for keyboard ;) Currently it feels like UX is going in touchscreen direction.

However I do agree with the point about the novice user not knowing this stuff but there are plenty of other things to fix for Novice users as well. :D

Something must be first :)

In T10402#180629, @mglb wrote:
  1. An escape value if you destroy the UI by accident (e.g. by deleting the default panel) without needing to right-click

When last panel is being removed, an user is asked for confirmation. After confirmation, the panel is removed and menu button appears in the panel's place (like it was always here, but was hidden under the panel). The button is movable.

This way:

  • Most users who doesn't need it won't see it
  • Someone who removed last panel (by mistake) will notice it immediatelly - this will be something new, in a place where the user is looking. Current button is probably seen by user's brain as a part of wallpaper after some time.
  • Advanced user who intentionally removed last panel will disable the button like it is done currently. At this point there is (at least) KRunner, so the user is not really stuck. Also, if someone clicks "remove panel", agrees to remove the panel in a message box, misses message with "undo" button, opens the "emergency menu", desktop settings, "Tweaks" tab, unchecks "show the desktop toolbox", all by mistake, the only option is to introduce "child mode" with all settings locked with password.

Makes sense to me!

Displays the name of the current activity when it's not in the corner

The "name of current activity" feature is not very discoverable since it requires dragging the widget out of a corner

  1. A visible way to see the name of the current activity

People should be able to see the name of the current activity (if there are more than one).

What about Activity Bar? This is what widgets are for. This way is even more flexible (name on a panel? No problem).

Yeah, if we add the Activity Bar widget by default and make it behave like the pager in that it would be invisible when there's only one activity, that seems like a good solution.

Offers a non-right-clicking method of accessing various (but not all) features present in the desktop's context menu -- most notably changing the wallpaper

They should be able to change the wallpaper without having to right-click on the desktop.

  1. A way to change the wallpaper without needing to right-click

Launcher → System Settings → ... huh, I didn't know this is not here :)
I think this is how it should be resolved. It is done so in all popular systems (desktop and mobile) and some other Linux desktops (at least Gnome)

I agree. Unfortunately it's not so easy. See https://bugs.kde.org/show_bug.cgi?id=391485

Yeah. There are many circumstances where right-click isn't good enough or even usable at all:

  • When you're using a touchscreen
  • When you're using a laptop with a buttonless touchpad that makes right-clicking hard and annoying
  • When you're a novice user, especially when paired with a laptop that has a buttonless touchpad

This should be fixed:

  • Touchscreen, weird touchpad: tap-and-hold

I believe this is currently under discussion but there seem to be folks who aren't a fan of making this a global thing for various reasons. The Plasma people can probably provide further comment.

Right-clicking is an accelerator for experts, not a general-purpose user interface.

Do you know any research about it (serious question)? I mean right-click, tap-and-hold, or equivalent, not exactly right click in mouseless/touchpadless environment.

I thought I could recall a bunch, but academic research turns out to be surprisingly difficult to find. Anecdotal evidence seems to generally be on the size of "many users don't use context menus" (for example https://ask.metafilter.com/146023/What-are-context-menus-for) but this is of course quite unscientific. However it's in line with my personal experiences.

In addition, Android, Windows, and macOS user interface guidelines all do echo the advice to make context menus shortcuts rather than the only place you can find something:

mglb added a comment.Apr 3 2019, 8:54 PM

I agree. Unfortunately it's not so easy. See https://bugs.kde.org/show_bug.cgi?id=391485

I'll make a mockup and write my reasons in the bug report soon. Right mouse button aside, I dislike current solution as a multi-screen user.

I believe this is currently under discussion but there seem to be folks who aren't a fan of making this a global thing for various reasons. The Plasma people can probably provide further comment.

Can you point me to the discussion? Hard to say anything without it.

I thought I could recall a bunch, but academic research turns out to be surprisingly difficult to find. Anecdotal evidence seems to generally be on the size of "many users don't use context menus" (for example https://ask.metafilter.com/146023/What-are-context-menus-for) but this is of course quite unscientific. However it's in line with my personal experiences.

In addition, Android, Windows, and macOS user interface guidelines all do echo the advice to make context menus shortcuts rather than the only place you can find something:

Thanks! I was interested generally in the right button, as various sources tell how right-click is bad and undiscoverable, while at the same time tap-and-hold (selecting items, tooltip) or even multi finger gestures are OK. Gnome HIG pointed me to a very good reason against right-click - assistive technology devices. In some cases one can't click another button, but holding existing one is still possible.

Generally, knowing a reason behind a rule helps with design :)

Gnome HIG: https://developer.gnome.org/hig/stable/pointer-and-touch-input.html.en

ngraham added subscribers: mart, hein.Apr 3 2019, 9:01 PM

I believe this is currently under discussion but there seem to be folks who aren't a fan of making [press-and-hold for context menu] a global thing for various reasons. The Plasma people can probably provide further comment.

Can you point me to the discussion? Hard to say anything without it.

Probably @mart and @hein would need to join the discussion but for a preview, see https://phabricator.kde.org/D20042#439381

When we're at the possibility of "how to restore default panels when someone messes up things or remove all panels", why not add the option of restoring desktop/panel defaults to the desktop context menu? Of course, there would have to be confirmation pop-up (like: do you really want to do it, this action is irreversible and will bring your desktop space to default setup).

It's easier to point people "right click on a desktop's empty space and choose X option" then explain the tooltip or which configs must be deleted.

I just saw few topics on Manjaro forum from newbie Plasma users who wanted to restore defaults so this is a valid concern. However, Desktop Toolbox WAS NOT DISCOVERED AS SOLUTION. So it completely fails to do its task.

On that note, it doesn't matter what Desktop Toolbox does, because:

  1. it's undiscoverable and unintuitive so people don't use it anyway
  2. it's in the way of desktop usage
  3. it's the ultimate awkward solution (nobody likes it, it's horrible when it comes to design and not comprehensible by users)
  4. such a solution is unknown outside Plasma so newbies don't understand why is it there and what it does, the natural instinct is to get rid of it right away
mglb added a comment.Apr 4 2019, 3:18 PM

When we're at the possibility of "how to restore default panels when someone messes up things or remove all panels", why not add the option of restoring desktop/panel defaults to the desktop context menu? Of course, there would have to be confirmation pop-up (like: do you really want to do it, this action is irreversible and will bring your desktop space to default setup).

There is add panel →default. Nobody should need full settings reset, especially in so easily discoverable place.

I just saw few topics on Manjaro forum from newbie Plasma users who wanted to restore defaults so this is a valid concern. However, Desktop Toolbox WAS NOT DISCOVERED AS SOLUTION. So it completely fails to do its task.

Why did they want to do it? This is (maybe bad) solution for some problem. We need to fix problems, not make them easier to fix in arbitrary ways by users.

mglb added a comment.Apr 4 2019, 10:56 PM

Another option:

  • Press <some shortcut>
  • This appears:

A tool like this would provide a way to fix mistakes like panel removal or system-related problems. <some shortcut> could be suggested to an user before they agree to remove last panel (like it is done after turning off a window border).

As for discoverability - the shortcut could be shown next to the program entry in launcher menu.